use conjure_object::serde::{ser, de};
use conjure_object::serde::ser::SerializeMap as SerializeMap_;
use conjure_object::private::{UnionField_, UnionTypeField_};
use std::fmt;
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub enum CheckStatus {
    /// The check was evaluated and is currently in state PASS.
    Pass(super::Pass),
    /// The check was evaluated and is currently in state FAIL.
    Fail(super::Fail),
    /// The check was evaluated and is currently in state INVALID.
    /// This signifies that the check could not be evaluated due to an internal error or
    /// if an overly expensive computation was attempted.
    Invalid(super::Invalid),
    /// The check was skipped and was not evaluated.
    /// This typically occurs when the check performs operations that are not supported in the streaming context,
    /// or if the required channels could not be resolved.
    Skipped(super::Skipped),
    /// An unknown variant.
    Unknown(Unknown),
}
impl ser::Serialize for CheckStatus {
    fn serialize<S>(&self, s: S) -> Result<S::Ok, S::Error>
    where
        S: ser::Serializer,
    {
        let mut map = s.serialize_map(Some(2))?;
        match self {
            CheckStatus::Pass(value) => {
                map.serialize_entry(&"type", &"pass")?;
                map.serialize_entry(&"pass", value)?;
            }
            CheckStatus::Fail(value) => {
                map.serialize_entry(&"type", &"fail")?;
                map.serialize_entry(&"fail", value)?;
            }
            CheckStatus::Invalid(value) => {
                map.serialize_entry(&"type", &"invalid")?;
                map.serialize_entry(&"invalid", value)?;
            }
            CheckStatus::Skipped(value) => {
                map.serialize_entry(&"type", &"skipped")?;
                map.serialize_entry(&"skipped", value)?;
            }
            CheckStatus::Unknown(value) => {
                map.serialize_entry(&"type", &value.type_)?;
                map.serialize_entry(&value.type_, &value.value)?;
            }
        }
        map.end()
    }
}
impl<'de> de::Deserialize<'de> for CheckStatus {
    fn deserialize<D>(d: D) -> Result<CheckStatus, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_map(Visitor_)
    }
}
struct Visitor_;
impl<'de> de::Visitor<'de> for Visitor_ {
    type Value = CheckStatus;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("union CheckStatus")
    }
    fn visit_map<A>(self, mut map: A) -> Result<CheckStatus, A::Error>
    where
        A: de::MapAccess<'de>,
    {
        let v = match map.next_key::<UnionField_<Variant_>>()? {
            Some(UnionField_::Type) => {
                let variant = map.next_value()?;
                let key = map.next_key()?;
                match (variant, key) {
                    (Variant_::Pass, Some(Variant_::Pass)) => {
                        let value = map.next_value()?;
                        CheckStatus::Pass(value)
                    }
                    (Variant_::Fail, Some(Variant_::Fail)) => {
                        let value = map.next_value()?;
                        CheckStatus::Fail(value)
                    }
                    (Variant_::Invalid, Some(Variant_::Invalid)) => {
                        let value = map.next_value()?;
                        CheckStatus::Invalid(value)
                    }
                    (Variant_::Skipped, Some(Variant_::Skipped)) => {
                        let value = map.next_value()?;
                        CheckStatus::Skipped(value)
                    }
                    (Variant_::Unknown(type_), Some(Variant_::Unknown(b))) => {
                        if type_ == b {
                            let value = map.next_value()?;
                            CheckStatus::Unknown(Unknown { type_, value })
                        } else {
                            return Err(
                                de::Error::invalid_value(de::Unexpected::Str(&type_), &&*b),
                            )
                        }
                    }
                    (variant, Some(key)) => {
                        return Err(
                            de::Error::invalid_value(
                                de::Unexpected::Str(key.as_str()),
                                &variant.as_str(),
                            ),
                        );
                    }
                    (variant, None) => {
                        return Err(de::Error::missing_field(variant.as_str()));
                    }
                }
            }
            Some(UnionField_::Value(variant)) => {
                let value = match &variant {
                    Variant_::Pass => {
                        let value = map.next_value()?;
                        CheckStatus::Pass(value)
                    }
                    Variant_::Fail => {
                        let value = map.next_value()?;
                        CheckStatus::Fail(value)
                    }
                    Variant_::Invalid => {
                        let value = map.next_value()?;
                        CheckStatus::Invalid(value)
                    }
                    Variant_::Skipped => {
                        let value = map.next_value()?;
                        CheckStatus::Skipped(value)
                    }
                    Variant_::Unknown(type_) => {
                        let value = map.next_value()?;
                        CheckStatus::Unknown(Unknown {
                            type_: type_.clone(),
                            value,
                        })
                    }
                };
                if map.next_key::<UnionTypeField_>()?.is_none() {
                    return Err(de::Error::missing_field("type"));
                }
                let type_variant = map.next_value::<Variant_>()?;
                if variant != type_variant {
                    return Err(
                        de::Error::invalid_value(
                            de::Unexpected::Str(type_variant.as_str()),
                            &variant.as_str(),
                        ),
                    );
                }
                value
            }
            None => return Err(de::Error::missing_field("type")),
        };
        if map.next_key::<UnionField_<Variant_>>()?.is_some() {
            return Err(de::Error::invalid_length(3, &"type and value fields"));
        }
        Ok(v)
    }
}
#[derive(PartialEq)]
enum Variant_ {
    Pass,
    Fail,
    Invalid,
    Skipped,
    Unknown(Box<str>),
}
impl Variant_ {
    fn as_str(&self) -> &'static str {
        match *self {
            Variant_::Pass => "pass",
            Variant_::Fail => "fail",
            Variant_::Invalid => "invalid",
            Variant_::Skipped => "skipped",
            Variant_::Unknown(_) => "unknown variant",
        }
    }
}
impl<'de> de::Deserialize<'de> for Variant_ {
    fn deserialize<D>(d: D) -> Result<Variant_, D::Error>
    where
        D: de::Deserializer<'de>,
    {
        d.deserialize_str(VariantVisitor_)
    }
}
struct VariantVisitor_;
impl<'de> de::Visitor<'de> for VariantVisitor_ {
    type Value = Variant_;
    fn expecting(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt.write_str("string")
    }
    fn visit_str<E>(self, value: &str) -> Result<Variant_, E>
    where
        E: de::Error,
    {
        let v = match value {
            "pass" => Variant_::Pass,
            "fail" => Variant_::Fail,
            "invalid" => Variant_::Invalid,
            "skipped" => Variant_::Skipped,
            value => Variant_::Unknown(value.to_string().into_boxed_str()),
        };
        Ok(v)
    }
}
///An unknown variant of the CheckStatus union.
#[derive(Debug, Clone, PartialEq, Eq, PartialOrd, Ord, Hash)]
pub struct Unknown {
    type_: Box<str>,
    value: conjure_object::Any,
}
impl Unknown {
    /// Returns the unknown variant's type name.
    #[inline]
    pub fn type_(&self) -> &str {
        &self.type_
    }
}
